
#include <netinet/in.h>

//#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
//#include <error.h>
#include <string.h>
//#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <net/route.h>

#define sin_addr(s) (((struct sockaddr_in *)(s))->sin_addr)


static int
route_manip(int cmd, char *name, int metric, char *dst, char *gateway, char *genmask)
{
	int s;
	struct rtentry rt;

	/* Open a raw socket to the kernel */
	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		goto err;

	/* Fill in rtentry */
	memset(&rt, 0, sizeof(rt));
	if (dst)
		inet_aton(dst, &sin_addr(&rt.rt_dst));
	if (gateway)
		inet_aton(gateway, &sin_addr(&rt.rt_gateway));
	if (genmask)
		inet_aton(genmask, &sin_addr(&rt.rt_genmask));
	rt.rt_metric = metric;
	rt.rt_flags = RTF_UP;
	if (sin_addr(&rt.rt_gateway).s_addr)
		rt.rt_flags |= RTF_GATEWAY;
	if (sin_addr(&rt.rt_genmask).s_addr == INADDR_BROADCAST)
		rt.rt_flags |= RTF_HOST;
	//rt.rt_dev = name;
	rt.rt_dev = NULL;

	/* Force address family to AF_INET */
	rt.rt_dst.sa_family = AF_INET;
	rt.rt_gateway.sa_family = AF_INET;
	rt.rt_genmask.sa_family = AF_INET;
		
	if (ioctl(s, cmd, &rt) < 0)
		goto err;

	close(s);
	return 0;

 err:
	close(s);
	perror(name);
	return errno;
}


int
route_add(char *name, int metric, char *dst, char *gateway, char *genmask)
{
	return route_manip(SIOCADDRT, name, metric, dst, gateway, genmask);
}

int
route_del(char *name, int metric, char *dst, char *gateway, char *genmask)
{
	return route_manip(SIOCDELRT, name, metric, dst, gateway, genmask);
}

int main(int argc, char **argv)
{
	int cmd;
	int active;
	int private;	
	int metric;
	char *dst;
        char *gateway;
        char *genmask;
	
	if(argc != 10 ){
		printf("Usage: stroute 0|1  cat /tmp/configs/static_route_num -- 0| del 1| add\n");
		return -1;
	}
	
	cmd = atoi(argv[1]);
	active = atoi(argv[4]);
	metric = atoi(argv[8]);
	dst = argv[5];
	gateway = argv[7];
	genmask = argv[6];
	
	//printf("%d %d %s %s %s \n",cmd, metric, dst, gateway, genmask);
	if((cmd == 1) && (active == 1))
		route_add(NULL, metric, dst, gateway, genmask);
	if((cmd == 0) && (active == 1))
		route_del(NULL, metric, dst, gateway, genmask);

	return 0;
	//route_del(NULL, 0, "199.168.1.0", "172.17.145.189", "255.255.255.0");

}

